GBA GFX is a simple dialog based program allowing you to edit Gameboy Advance sprites and tile sets.

Gameboy Advance® is a Trademark of Nintendo.

This software is released under the GNU General Public License.

This software comes with ABSOLUTELY NO WARRENTY; see license for details.


The Dialog

Click on different regions of the dialog to get help on that area.

Editing Area Palette Control Edit Control Object Selection Object Control Buttons


Editing

Editing is done in the area shown above. In all drawing modes, the left mouse button will draw in the selected foreground colour, while the right mouse button draws in the background colour. Different drawing modes can be selected with the edit controls. The following modes are available:

  • Plot
  • Line
  • Circle/Filled Circle
  • Ellipse/Filled Ellipse
  • Rectangle/Filled Rectangle
  • Fill
  • Copy/Paste mode

Below the edit control is a text entry that allows you to set the name of the sprite. The use of this is described in generate sources help. The name can be left blank if you do not need them.

Plot

This mode simply plots single pixels onto the grid. You can draw while holding down the mouse to 'paint'.

Line

Draw a line by dragging it with the mouse button.

Circle/Filled Circle

Draw a circle by dragging it with the mouse button.

Ellipse/Filled Ellipse

Draw an ellipse by dragging it with the mouse button.

Rectangle/Filled Rectangle

Draw a rectangle by dragging it with the mouse button.

Fill

Flood fill an area by clicking the mouse button.

Copy/Paste mode

Mark an area to copy by dragging with the left mouse button.

To copy or cut the selected area right click and select from the pop-up menu as appropriate.

Once an area has been copied, right click and select from the pop-up menu to paste it. Paste Transparent means that the currently selected background colour will be transparent on the pasted block. Once selected move the mouse to position the block and drop it in place with the left mouse button. Note that the paste can be cancelled from the pop-up menu.

At any time the Paste Gravity can be altered from the pop-up menu. This simply alters where the cursor is anchored to the block when pasting, allowing the block to be positioned anywhere.


Palette Control

The selection of colours is controlled in the area shown above.

Foreground sets the current foreground palette entert for editing.

Background sets the current background palette entert for editing.

Select allows you to select the colour of the foreground palette entry. Note that the standard Windows colour selector is used; once selected the colour is modifed to Gameboy Advance format (i.e. with 5 bits per red/green/blue colour, rather than Window's 8).

Palette and 16 Colour Mode is used to select 16 colour mode and the palette number for this sprite. When in 16 colour mode there are 16 available palettes numbered 0 to 15, each with 16 colours. If this mode is not selected then your sprites are constructed using one 256 colour palette.


Edit Control

Editing is controlled in the area shown above.

Mode allows you to set the current drawing mode. See the section on editing for details.

The Scroll buttons allow you to scroll the currently edit in all four directions.

The Flip buttons allow you to flip the current edit horizontally or vertically.

The Sprite Size combo allows you to select the size of this sprite from all allowable Gameboy Advance sizes. When using GBA GFX to edit tiles, keep this at 8x8.

Clear clears the current edit to the background colour. Undo (or pressing CONTROL+Z) undoes the last edit.


Object Selection

The selection of which sprite to edit is controlled here.

No Used tells you the total number of sprites you've created. Note that there is always one sprite.

Object is used to select the object to edit. A preview of the selected object is shown in the black box below the controls.

Note that whether the object selected appears in the edit region is controlled by the Object Control buttons.


Object Control

The sprite set is controlled from these buttons.

Add adds a new sprite to the end of the set of sprites. Insert Here adds a new one at the current position in the set defined by the Object Selection controls.

WARNING: Note that GBA GFX does not restrict the number of sprites you can create within one set.

Delete Current deletes the current selected sprite. Delete All deletes all the sprites in the set.

Edit copies the current selected sprite to the editing area. Store stores the current edit in the current selected sprite.

If the Auto Store/Edit checkbox is marked then whenever a sprite is selected with the Object Selection controls the current edit is automatically stored and the newly selected sprite is loaded for editing.

The Import button is explained here.

Pressing Map Edit brings up the Map Editor (controversially), which is explained here.


Import

Note: that the import functionality is current very basic.

Sprites can be imported from Windows bitmap (BMP) files using the above dialog.

The top section of the dialog allows you to select the bitmap to load.

Currently only 16 colour and 256 colour uncompressed bitmaps are supported. Also only 256 colour bitmaps can be imported when GBA GFX is in 256 colour mode. Only 16 colour bitmaps can be imported when GBA GFX is in 16 colour mode.

The next part of the dialog controls how the sprites will be imported. If Import Multiple Sprites is selected then as many sprites as possible will be grabbed from the bitmap. If this is not selected then only one sprite from the top left hand corner of the bitmap will be imported.

Import Palette allows you to grab the palette from the bitmap. If GBA GFX is in 16 colour mode then the palette number the bitmap's palette will be imported into can be selected.

Sprite Size sets the sprite size that will be grabbed from the bitmap.

The next section simply shows some information on the bitmap, including how many colours are in the bitmap palette; how many sprites across, down and the total number that could be grabbed from the bitmap; the width and height of the bitmap.

Select the Show Preview button to display a quick preview of the bitmap overlayed with a white grid showing where sprites will be grabbed from.

Select the OK button to start the import. Note that the sprites are grabbed from the top left hand corner of the bitmap, going across then down. The grabbed sprites are stored at the end of the current set of sprites.


Buttons

The buttons at the bottom of the dialog control loading and saving of the sprite set and exit (warning: GBA GFX exits without any confirmation) with the Load, Save and Exit buttons.

Generation of C sources is done with the Generate C button which is explained hereh.

Note that when saving the settings last used for the Generate C button (if any) will be saved with the sprite data.


C Code Generation

NOTE: This section assumes you understand the C programming language and Gameboy Advance programming.

This dialog is presented when you select the Generate C option. The Directory field lets you select which directory the generated source and header will be written into.

The Filename allows you to enter what the sources will be called. Note that no extensions are required; entering foo here will create foo.c and foo.h.

The Array entry allows you to provide a basename for the generated arrays and #defines. For example, entering bar here will create the following header file:

#ifndef FOO_H
#define FOO_H

#ifdef _cplusplus
extern "C" {
#endif

#define BAR_PAL256 0

extern const unsigned short bar_pal[256];
#define BAR_DATA_LEN 1488
extern const unsigned short bar_data[1488];

/* Sprite names
*/
#define A_SPRITE_NAME 12
#define ANOTHER_SPRITE_NAME 20

#ifndef GFXINFOTYPE
#define GFXINFOTYPE

/* Remember to add 512 to tile no when using bitmapped modes
*/
typedef struct
    {
    int pal;
    int tile;
    int width;
    int height;
    int shape1;
    int shape2;
    } GFXInfoType;

#endif

#define BAR_NO 30
extern const GFXInfoType bar_info[BAR_NO];

#ifdef _cplusplus
}
#endif

#endif

Going from the top of the header, these definitions and arrays are created:

BAR_PAL256
This defines whether the sprites are 256 colour or not. zero indicates 16 colour mode, one 256 colour mode.

bar_pal[]
This is the palette data. It is always 256 16-bit words long.

BAR_DATA_LEN
BAR_DATA_LEN defines the length of the sprite data (in 16-bit words).

bar_data[]
This is the sprite data itself.

A_SPRITE_NAME
If sprites have been named, then the names are defined here so that the bar_info array can be accessed symbolically. Note that while any text can be entered into the sprite name in the editor, once code is generated the following rules are applied:

  • All letters are converted to upper case.
  • Spaces are converted to underscores.
  • Characters apart from A-Z, 0-9 and underscore are discarded.
  • Underscores/spaces at the start of the name are discarded. (Read the ANSI C Standard if this confuses you!)

BAR_NO
This defines the number of sprites in the set.

bar_info
This defines information for each sprite.
pal indicates the palette number if 16 colour mode is being used.
tile is the tile number the sprite starts at. As the comment says 512 should be added to this when using the sprites in bitmapped modes.
width and height are the size of the sprite in pixels.
shape1 and shape2 are the unshifted shape values for the size of the sprite (as used in the sprite registers).

Using the generated code

To use code generated, simply #include the created header where needed, compile the source file to an object file and link it in with your executable.

Note that the source file is not dependent on (i.e. does not include) the header!

Note on 1D/2D sprite data

Note that this tool always generates sprite data in 1D format. This is so that the Map Editor can edit using tiles bigger than 8x8, whilst still being able to work out which tile number to put in the map.


The Map Editor

Click on different regions of the dialog to get help on that area.

Note that although the GBA will only allow 8x8 tiles to be used to define a map, GBA GFX will let you edit a map with larger tiles. It will automatically set the proper tile values according to how the tile set will be generated.

Map Editing Area Map Editing Control Map Control Buttons


Map Editing

Editing is done in the area shown above. In all drawing modes, either mouse button will draw using the currently selected tile.

Different drawing modes can be selected with the map edit controls. The following modes are available:

  • Plot
  • Line
  • Circle/Filled Circle
  • Ellipse/Filled Ellipse
  • Rectangle/Filled Rectangle
  • Fill
  • Text
  • Copy/Paste mode

Below the editing area is a black block with a white block inside it. You can use this to alter which bit of the map is displayed if the map is too big to fit in the editing area. Simply drag the white block with the mouse to move it. The current position in the map is displayed as an X,Y co-ordinate pair. The Nudge buttons can be used to nudge it one character cell in the appropriate direction.

Plot

This mode simply plots single tiles onto the grid. You can draw while holding down the mouse to 'paint'.

Line

Draw a line by dragging it with the mouse button.

Circle/Filled Circle

Draw a circle by dragging it with the mouse button.

Ellipse/Filled Ellipse

Draw an ellipse by dragging it with the mouse button.

Rectangle/Filled Rectangle

Draw a rectangle by dragging it with the mouse button.

Fill

Flood fill an area by clicking the mouse button. Note that if the area is big then it may not be filled correctly (sorry - just my dodgy quick and dirty fill routine uses too much stack).

The fill will try and be intelligent if tiles larger than 8x8 have been used - each seperate 8x8 part of the large tile will be filled in. Try it and see!

Text

This allows you to enter text easily into a map. Don't ask me - it seemed a good idea at the time.

Key to tile mappings are defined using the text mapping dialog.

To use this, simply press the keys to enter your string of text. The only editing available is BACKSPACE, which deletes the last entered character. Once you have finished your text you can move the pointer to position it, then pressing the button sets it in place.

Note that the text entry will honour the current Horizontal Flip setting, so that backwards text will be written backwards. Try it to see what I mean.

Also note that if no mapping has been setup for the SPACE bar, then pressing it will leave a gap.

Copy/Paste mode

The copy/paste works much as it does when editing sprites, except that there is no transparent paste option.

The only additional feature is the inclusion of an option to select an area and then alter the Flip Horizontal and Flip Vertical settings of the selected area. The menu options should be fairly self explanatary (no really - I'm not getting bored writing this help file...)


Map Edit Control

The drawing of tiles is controlled here.

The Mode allows the drawing mode to be selected. The different modes are explained here.

Anchor sets how tiles bigger than 8x8 are anchored. In all drawing modes, apart from Plot and Text, where the shape is drawn from will be set as the anchor for the tile (try it with a large tile and drawing a filled rectangle to see what I mean). However, this anchor point is reset for each drawing operation. By checking the box this anchor will not be reset. To illustrate this, try drawing some lines with large tiles with the anchor off, then try again with the anchor on.

Note that larger tiles are drawn correctly, so that the flip commands (see below) are honoured and the tile is still drawn correctly.

Zoom allows you to zoom into the map for easier editing. Note that zoom level zero draws the tiles half sized, so that an overview of a map can be seen a bit more easily.

Tile selects the tile to be used for drawing, and the start tile in the sequential drawing mode.

Flip Horiz (only when editing non-rotational maps) means that the tiles will be drawn horizontally flipped. Flip Vert does the same, but vertically.


Map Control

Contol of the map is done in the area shown above.

Map Size sets the size of the current map.

Rotate/Scale Map sets whether this map is going to be used for a normal text map, or a rotating/scaling map on the Gameboy Advance.

The Scroll Map buttons allow the map to be scrolled around (just like the sprite edit controls).

Flip Map will flip the map vertically or horizontally. Note that if this is a normal map you will also be asked if you want to flip the tiles themselves as well.

Undo undoes and redoes the last operation (or just press Control and Z). Clear to current will clear the map so it is full of the currently selected tile.

Text Mappings sets the mappings for the Text drawing mode, and is explained here.


Text to Tile Mapping

This dialog allows the text mode in the Map Edit Dialog to be configured.

The Current Mappings show you which tile (only as a number, sorry) has been mapped to which key. Select the character you wish to map with the Key drop down list and the tile you want to map it to in the Tile. Then simply press the Set button to set the mapping, or Clear to remove the current mapping for the selected key.

The Set/Next Both button sets the currently selected key to the selected tile, and then moves both lists onto their next entry. This is handy for setting up letters and numbers quickly (assuming the tiles are in the right order).

The Set/Next does a similar job, but only moves the selected key onto the next value.

The Clear/Next clears the mapping for the currently selected key, and then moves the key selection onto the next key.

Clear All clears all mappings.


Buttons

The Generate C button generates C source code. This is explained in more detail here.

The Save and Load buttons work as expected. Note that when saving a map the last settings used for Generate C and the current Text Mappings are saved along with the map. Tile/Sprite data is not saved - different tile sets can be used for the same map (as on the Gameboy Advance itself).

Exit takes you back to the main dialog. Note that the map will be as you left it next time you edit it from here. Unless tiles which where in the map have been deleted, in which case those tiles will be set to the current last tile. Also if the palette mode has changed and is incompatible with a rotate/scale map that will be changed automatically.


C Code Generation

NOTE: This section assumes you understand the C programming language and Gameboy Advance programming.

This dialog is presented when you select the Generate C option. The Directory field lets you select which directory the generated source and header will be written into.

The Filename allows you to enter what the sources will be called. Note that no extensions are required; entering foo here will create foo.c and foo.h.

The Array entry allows you to provide a basename for the generated arrays and #defines. For example, entering bar here will create the following header file:

#ifndef FOO_H
#define FOO_H

#ifdef _cplusplus
extern "C" {
#endif

#define BAR_ROT 0

#define BAR_COL 128

#define BAR_SIZE 0

#define BAR_DATA_LEN 1024
extern const unsigned short bar_data[1024];

#ifdef _cplusplus
}
#endif

#endif

Going from the top of the header, these definitions and arrays are created:

BAR_ROT
This is set to one if the map is a rotate/scale map.

BAR_COL
This is the colour setting to use in the REG_BG?CNT register for this map.

BAR_SIZE
This is the size setting to use in the REG_BG?CNT register for this map.

bar_data[]
This is the map data itself.

Using the generated code

To use code generated, simply #include the created header where needed, compile the source file to an object file and link it in with your executable.

Note that the source file is not dependent on (i.e. does not include) the header!


GNU GENERAL PUBLIC LICENSE

Version 2, June 1991

Copyright (C) 1989, 1991 Free Software Foundation, Inc.
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.

Preamble

The licenses for most software are designed to take away your freedom to share and change it. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change free software--to make sure the software is free for all its users. This General Public License applies to most of the Free Software Foundation's software and to any other program whose authors commit to using it. (Some other Free Software Foundation software is covered by the GNU Library General Public License instead.) You can apply it to your programs, too.

When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for this service if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs; and that you know you can do these things.

To protect your rights, we need to make restrictions that forbid anyone to deny you these rights or to ask you to surrender the rights. These restrictions translate to certain responsibilities for you if you distribute copies of the software, or if you modify it.

For example, if you distribute copies of such a program, whether gratis or for a fee, you must give the recipients all the rights that you have. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.

We protect your rights with two steps: (1) copyright the software, and (2) offer you this license which gives you legal permission to copy, distribute and/or modify the software.

Also, for each author's protection and ours, we want to make certain that everyone understands that there is no warranty for this free software. If the software is modified by someone else and passed on, we want its recipients to know that what they have is not the original, so that any problems introduced by others will not reflect on the original authors' reputations.

Finally, any free program is threatened constantly by software patents. We wish to avoid the danger that redistributors of a free program will individually obtain patent licenses, in effect making the program proprietary. To prevent this, we have made it clear that any patent must be licensed for everyone's free use or not licensed at all.

The precise terms and conditions for copying, distribution and modification follow.

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. This License applies to any program or other work which contains a notice placed by the copyright holder saying it may be distributed under the terms of this General Public License. The "Program", below, refers to any such program or work, and a "work based on the Program" means either the Program or any derivative work under copyright law: that is to say, a work containing the Program or a portion of it, either verbatim or with modifications and/or translated into another language. (Hereinafter, translation is included without limitation in the term "modification".) Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not covered by this License; they are outside its scope. The act of running the Program is not restricted, and the output from the Program is covered only if its contents constitute a work based on the Program (independent of having been made by running the Program). Whether that is true depends on what the Program does.

1. You may copy and distribute verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice and disclaimer of warranty; keep intact all the notices that refer to this License and to the absence of any warranty; and give any other recipients of the Program a copy of this License along with the Program.

You may charge a fee for the physical act of transferring a copy, and you may at your option offer warranty protection in exchange for a fee.

2. You may modify your copy or copies of the Program or any portion of it, thus forming a work based on the Program, and copy and distribute such modifications or work under the terms of Section 1 above, provided that you also meet all of these conditions:

  • a) You must cause the modified files to carry prominent notices stating that you changed the files and the date of any change.

  • b) You must cause any work that you distribute or publish, that in whole or in part contains or is derived from the Program or any part thereof, to be licensed as a whole at no charge to all third parties under the terms of this License.

  • c) If the modified program normally reads commands interactively when run, you must cause it, when started running for such interactive use in the most ordinary way, to print or display an announcement including an appropriate copyright notice and a notice that there is no warranty (or else, saying that you provide a warranty) and that users may redistribute the program under these conditions, and telling the user how to view a copy of this License. (Exception: if the Program itself is interactive but does not normally print such an announcement, your work based on the Program is not required to print an announcement.)
These requirements apply to the modified work as a whole. If identifiable sections of that work are not derived from the Program, and can be reasonably considered independent and separate works in themselves, then this License, and its terms, do not apply to those sections when you distribute them as separate works. But when you distribute the same sections as part of a whole which is a work based on the Program, the distribution of the whole must be on the terms of this License, whose permissions for other licensees extend to the entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest your rights to work written entirely by you; rather, the intent is to exercise the right to control the distribution of derivative or collective works based on the Program.

In addition, mere aggregation of another work not based on the Program with the Program (or with a work based on the Program) on a volume of a storage or distribution medium does not bring the other work under the scope of this License.

3. You may copy and distribute the Program (or a work based on it, under Section 2) in object code or executable form under the terms of Sections 1 and 2 above provided that you also do one of the following:

  • a) Accompany it with the complete corresponding machine-readable source code, which must be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,

  • b) Accompany it with a written offer, valid for at least three years, to give any third party, for a charge no more than your cost of physically performing source distribution, a complete machine-readable copy of the corresponding source code, to be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,

  • c) Accompany it with the information you received as to the offer to distribute corresponding source code. (This alternative is allowed only for noncommercial distribution and only if you received the program in object code or executable form with such an offer, in accord with Subsection b above.)
The source code for a work means the preferred form of the work for making modifications to it. For an executable work, complete source code means all the source code for all modules it contains, plus any associated interface definition files, plus the scripts used to control compilation and installation of the executable. However, as a special exception, the source code distributed need not include anything that is normally distributed (in either source or binary form) with the major components (compiler, kernel, and so on) of the operating system on which the executable runs, unless that component itself accompanies the executable.

If distribution of executable or object code is made by offering access to copy from a designated place, then offering equivalent access to copy the source code from the same place counts as distribution of the source code, even though third parties are not compelled to copy the source along with the object code.

4. You may not copy, modify, sublicense, or distribute the Program except as expressly provided under this License. Any attempt otherwise to copy, modify, sublicense or distribute the Program is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.

5. You are not required to accept this License, since you have not signed it. However, nothing else grants you permission to modify or distribute the Program or its derivative works. These actions are prohibited by law if you do not accept this License. Therefore, by modifying or distributing the Program (or any work based on the Program), you indicate your acceptance of this License to do so, and all its terms and conditions for copying, distributing or modifying the Program or works based on it.

6. Each time you redistribute the Program (or any work based on the Program), the recipient automatically receives a license from the original licensor to copy, distribute or modify the Program subject to these terms and conditions. You may not impose any further restrictions on the recipients' exercise of the rights granted herein. You are not responsible for enforcing compliance by third parties to this License.

7. If, as a consequence of a court judgment or allegation of patent infringement or for any other reason (not limited to patent issues), conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot distribute so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not distribute the Program at all. For example, if a patent license would not permit royalty-free redistribution of the Program by all those who receive copies directly or indirectly through you, then the only way you could satisfy both it and this License would be to refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under any particular circumstance, the balance of the section is intended to apply and the section as a whole is intended to apply in other circumstances.

It is not the purpose of this section to induce you to infringe any patents or other property right claims or to contest validity of any such claims; this section has the sole purpose of protecting the integrity of the free software distribution system, which is implemented by public license practices. Many people have made generous contributions to the wide range of software distributed through that system in reliance on consistent application of that system; it is up to the author/donor to decide if he or she is willing to distribute software through any other system and a licensee cannot impose that choice.

This section is intended to make thoroughly clear what is believed to be a consequence of the rest of this License.

8. If the distribution and/or use of the Program is restricted in certain countries either by patents or by copyrighted interfaces, the original copyright holder who places the Program under this License may add an explicit geographical distribution limitation excluding those countries, so that distribution is permitted only in or among countries not thus excluded. In such case, this License incorporates the limitation as if written in the body of this License.

9. The Free Software Foundation may publish revised and/or new versions of the General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Program specifies a version number of this License which applies to it and "any later version", you have the option of following the terms and conditions either of that version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of this License, you may choose any version ever published by the Free Software Foundation.

10. If you wish to incorporate parts of the Program into other free programs whose distribution conditions are different, write to the author to ask for permission. For software which is copyrighted by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions for this. Our decision will be guided by the two goals of preserving the free status of all derivatives of our free software and of promoting the sharing and reuse of software generally.

NO WARRANTY

11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs

If you develop a new program, and you want it to be of the greatest possible use to the public, the best way to achieve this is to make it free software which everyone can redistribute and change under these terms.

To do so, attach the following notices to the program. It is safest to attach them to the start of each source file to most effectively convey the exclusion of warranty; and each file should have at least the "copyright" line and a pointer to where the full notice is found.

one line to give the program's name and an idea of what it does.
Copyright (C) yyyy  name of author

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Also add information on how to contact you by electronic and paper mail.

If the program is interactive, make it output a short notice like this when it starts in an interactive mode:

Gnomovision version 69, Copyright (C) year name of author
Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
type `show w'.  This is free software, and you are welcome
to redistribute it under certain conditions; type `show c'
for details.

The hypothetical commands `show w' and `show c' should show the appropriate parts of the General Public License. Of course, the commands you use may be called something other than `show w' and `show c'; they could even be mouse-clicks or menu items--whatever suits your program.

You should also get your employer (if you work as a programmer) or your school, if any, to sign a "copyright disclaimer" for the program, if necessary. Here is a sample; alter the names:

Yoyodyne, Inc., hereby disclaims all copyright
interest in the program `Gnomovision'
(which makes passes at compilers) written
by James Hacker.

signature of Ty Coon, 1 April 1989
Ty Coon, President of Vice

This General Public License does not permit incorporating your program into proprietary programs. If your program is a subroutine library, you may consider it more useful to permit linking proprietary applications with the library. If this is what you want to do, use the GNU Library General Public License instead of this License.